package sun.audio;

import java.io.ByteArrayInputStream;

public class ContinuousAudioDataStream extends AudioDataStream {
   public ContinuousAudioDataStream(AudioData data) {
      super(data);
   }

   public int read() {
      int c = super.read();
      if (c == -1) {
         ((ByteArrayInputStream)this).reset();
         c = super.read();
      }

      return c;
   }

   public int read(byte[] buf, int pos, int len) {
      int count = 0;

      while(count < len) {
         int n = super.read(buf, pos + count, len - count);
         if (n >= 0) {
            count += n;
         } else {
            ((ByteArrayInputStream)this).reset();
         }
      }

      return count;
   }
}
